package com.lmco.spacefence.webservices.util;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.xml.bind.annotation.adapters.XmlAdapter;

public class XmlDateAdapter extends XmlAdapter<String, Date> {
    @Override
    public Date unmarshal(String value) {
    	System.out.println("***** " + this.getClass() + " unmarshalling String '" + value + "'");
        if (value == null) {
            return null;
        }
        return javax.xml.bind.DatatypeConverter.parseDate(value).getTime();
    }

    @Override
    public String marshal(Date value) {
    	System.out.println("***** " + this.getClass() + " marshalling Date '" + value + "'");
        if (value == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(value);
    }
}
