/*
 * Note: Information concerning change history is maintained by the version control system. This information, along with code relationship (e.g. used by, uses,
 * dependencies), is readily available through the Eclipse Integrated Development Environment.
 */

package com.lmco.spacefence.webservicetests.test;

import com.lmco.spacefence.webservices.util.XmlDateAdapter;
import com.lmco.spacefence.webservices.util.XmlDatetimeAdapter;

import org.apache.cxf.endpoint.Client;
import org.apache.cxf.frontend.ClientProxy;
import org.apache.cxf.interceptor.LoggingInInterceptor;
import org.apache.cxf.interceptor.LoggingOutInterceptor;
import org.junit.BeforeClass;
import org.junit.Test;

import java.net.URL;
import java.util.Calendar;
import java.util.Map;
import java.util.TimeZone;

import javax.xml.ws.BindingProvider;

import gov.c2ssa.c2ssadomain.spacefence.v2.test.TestType;
import gov.c2ssa.c2ssadomain.spacefence.v2.test.operations.TestResponse;
import gov.c2ssa.c2ssadomain.spacefence.v2.test.service.TestService;
import gov.c2ssa.c2ssadomain.spacefence.v2.test.service.TestServicePortType;

public class TestServiceTest {

    private static final Calendar createTime;
    static {
        createTime = Calendar.getInstance(TimeZone.getTimeZone("UTC"));
        createTime.set(Calendar.MILLISECOND, 0);
    }
    private static TestServicePortType port;

    @BeforeClass
    public static void beforeClassMethod() throws Exception {
        TestService service = new TestService(new URL("http://localhost:8080/NetCentric/TestService?wsdl"));
        port = service.getTestServicePort();
//        Map<String, Object> ctx = ((BindingProvider) port).getRequestContext();
//        ctx.put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, "http://localhost:8080/NetCentric/TestService");
        Client client = ClientProxy.getClient(port);
        client.getInInterceptors().add(new LoggingInInterceptor());
        client.getOutInterceptors().add(new LoggingOutInterceptor());

    }
    
    @Test
    public void test() throws Exception {
        gov.c2ssa.c2ssadomain.spacefence.v2.test.operations.Test test = new gov.c2ssa.c2ssadomain.spacefence.v2.test.operations.Test();
        test.setTestDate(createTime.getTime());
        test.setTestDatetime(createTime);
        TestResponse response = port.test(test);
        TestType testType = response.getTestType();
        System.out.println(testType.getResponseDate());
        System.out.println(testType.getResponseDatetime());
    }
    
//    @Test
//    public void test() throws Exception {
//        XmlDateAdapter dateAdapter = new XmlDateAdapter();
//        System.out.println(dateAdapter.marshal(createTime.getTime()));
//        XmlDatetimeAdapter datetimeAdapter = new XmlDatetimeAdapter();
//        System.out.println(datetimeAdapter.marshal(createTime));
//        gov.c2ssa.c2ssadomain.spacefence.v2.test.operations.Test test = new gov.c2ssa.c2ssadomain.spacefence.v2.test.operations.Test();
//        test.setTestDate(createTime.getTime());
//        test.setTestDatetime(createTime);
//        TestResponse response = port.test(test);
//        TestType testType = response.getTestType();
//        System.out.println(dateAdapter.marshal(testType.getResponseDate()));
//        System.out.println(datetimeAdapter.marshal(testType.getResponseDatetime()));
//    }
}